# -*- coding: utf-8 -*-
# Generated by Django 1.11.29 on 2022-03-15 20:06
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


def deduplicate_identifiers(apps, schema_editor):
    Identifier = apps.get_model("identifiers", "Identifier")
    Article = apps.get_model("submission", "Article")
    articles = Article.objects.all()
    for article in articles:
        identifiers_for_article = Identifier.objects.filter(article=article)
        for id_type in ['doi', 'uri', 'pubid']:
            identifiers_of_type = identifiers_for_article.filter(id_type=id_type)
            for doi_string in set(identifiers_of_type.values_list('identifier', flat=True)):
                to_keep = identifiers_of_type.filter(identifier=doi_string).order_by('-pk').first()
                duplicates = identifiers_of_type.filter(identifier=doi_string).exclude(pk=to_keep.pk)
                if duplicates:
                    # print('\n\n\n')
                    # print('To keep:')
                    # print(id_type, to_keep.pk, doi_string)
                    # print('Duplicates:')
                    # for dup in duplicates:
                    #     print(id_type, dup.pk, dup.identifier)
                    # print('\n\n\n')
                    duplicates.delete()


class Migration(migrations.Migration):
    atomic = False
    dependencies = [
        ('identifiers', '0008_batch_doi_registration_continued_20220524'),
    ]

    operations = [
        migrations.RunPython(deduplicate_identifiers, reverse_code=migrations.RunPython.noop),
    ]
